unbound: util/locks.c File Reference

unbound 0.1

Functions
locks.c File Reference

util/locks.c - unbound locking primitives More...

`#include "config.h"`
`#include "util/locks.h"`
`#include <signal.h>`

## Functions
void | ub_thread_blocksigs (void)
| block all signals, masks them away.
void | ub_thread_sig_unblock (int sig)
| unblock one signal, so we can catch it
void | ub_thr_fork_create (ub_thread_type *thr, void *(*func)(void *), void *arg)
| No threading available: fork a new process.
void | ub_thr_fork_wait (ub_thread_type thread)
| There is no threading.

## Detailed Description

util/locks.c - unbound locking primitives

Copyright (c) 2007, NLnet Labs. All rights reserved.

This software is open source.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

Neither the name of the NLNET LABS nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Implementation of locking and threading support. A place for locking debug code since most locking functions are macros.

## Function Documentation

## ◆ ub_thr_fork_create()

void ub_thr_fork_create | ( | ub_thread_type * | thr,
|  | void *(*)(void *) | func,
|  | void * | arg
| ) |  |

No threading available: fork a new process.

This means no shared data structure, and no locking. Only the main thread ever returns. Exits on errors.

Parameters

  thr | the location where to store the thread-id.
  func | function body of the thread. Return value of func is lost.
  arg | user argument to func.

References fatal_exit().

## ◆ ub_thr_fork_wait()

void ub_thr_fork_wait | ( | ub_thread_type | thread | ) |

There is no threading.

Wait for a process to terminate. Note that ub_thread_type is defined as pid_t.

Parameters

  thread | the process id to wait for.

References log_err(), and log_warn().